"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  show: true,
  list: true,
  buildOne: true,
  buildAll: true,
  addMany: true,
  loadExtension: true,
  ComponentFactoryExt: true,
  ComponentFactory: true,
  PkgExtension: true,
  DependencyResolverExtension: true,
  Workspace: true
};
exports.show = show;
exports.list = list;
exports.buildOne = buildOne;
exports.buildAll = buildAll;
exports.addMany = addMany;
exports.loadExtension = loadExtension;
Object.defineProperty(exports, "ComponentFactoryExt", {
  enumerable: true,
  get: function () {
    return _component().ComponentFactoryExt;
  }
});
Object.defineProperty(exports, "ComponentFactory", {
  enumerable: true,
  get: function () {
    return _component().ComponentFactory;
  }
});
Object.defineProperty(exports, "PkgExtension", {
  enumerable: true,
  get: function () {
    return _pkg().PkgExtension;
  }
});
Object.defineProperty(exports, "DependencyResolverExtension", {
  enumerable: true,
  get: function () {
    return _dependencyResolver().DependencyResolverExtension;
  }
});
Object.defineProperty(exports, "Workspace", {
  enumerable: true,
  get: function () {
    return _workspace().Workspace;
  }
});

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

function _index() {
  const data = require("./api/consumer/index");

  _index = function () {
    return data;
  };

  return data;
}

function _index2() {
  const data = require("./api/scope/index");

  _index2 = function () {
    return data;
  };

  return data;
}

function _extension() {
  const data = _interopRequireDefault(require("./legacy-extensions/extension"));

  _extension = function () {
    return data;
  };

  return data;
}

function _hooks() {
  const data = _interopRequireDefault(require("./hooks"));

  _hooks = function () {
    return data;
  };

  return data;
}

function _component() {
  const data = require("./extensions/component");

  _component = function () {
    return data;
  };

  return data;
}

function _pkg() {
  const data = require("./extensions/pkg");

  _pkg = function () {
    return data;
  };

  return data;
}

function _dependencyResolver() {
  const data = require("./extensions/dependency-resolver");

  _dependencyResolver = function () {
    return data;
  };

  return data;
}

var _harmony = require("@teambit/harmony");

Object.keys(_harmony).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _harmony[key];
    }
  });
});

function _workspace() {
  const data = require("./extensions/workspace");

  _workspace = function () {
    return data;
  };

  return data;
}

_hooks().default.init();

function show(scopePath, id, opts) {
  // @ts-ignore AUTO-ADDED-AFTER-MIGRATION-PLEASE-FIX!
  return (0, _index().getScopeComponent)({
    scopePath,
    id,
    allVersions: opts && opts.versions
  }).then(({
    component
  }) => {
    if (Array.isArray(component)) {
      return component.map(v => v.toObject());
    }

    return component.toObject();
  });
}

function list(scopePath) {
  return (0, _index2().scopeList)(scopePath).then(listScopeResult => listScopeResult.map(result => result.id.toString()));
}

function buildOne(_x) {
  return _buildOne.apply(this, arguments);
}

function _buildOne() {
  _buildOne = (0, _bluebird().coroutine)(function* (id, noCache = false, verbose = false, workspaceDir) {
    return (0, _index().build)(id, noCache, verbose, workspaceDir);
  });
  return _buildOne.apply(this, arguments);
}

function buildAll(_x2) {
  return _buildAll.apply(this, arguments);
}

function _buildAll() {
  _buildAll = (0, _bluebird().coroutine)(function* (id, noCache = false, verbose = false) {
    return (0, _index().buildAll)(noCache, verbose);
  });
  return _buildAll.apply(this, arguments);
}

function addMany(_x3, _x4) {
  return _addMany.apply(this, arguments);
} // TODO: gilad - make sure it works now with harmony, nothing will work without this working

/**
 * Load extension programmatically
 */


function _addMany() {
  _addMany = (0, _bluebird().coroutine)(function* (components, alternateCwd) {
    return (0, _index().addMany)(components, alternateCwd);
  });
  return _addMany.apply(this, arguments);
}

function loadExtension(_x5) {
  return _loadExtension.apply(this, arguments);
}

function _loadExtension() {
  _loadExtension = (0, _bluebird().coroutine)(function* (args) {
    const extension = yield _extension().default.load(args);
    return Promise.resolve(extension);
  });
  return _loadExtension.apply(this, arguments);
}