"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

function _harmony() {
  const data = _interopRequireWildcard(require("@teambit/harmony"));

  _harmony = function () {
    return data;
  };

  return data;
}

function _hooks() {
  const data = _interopRequireDefault(require("./hooks"));

  _hooks = function () {
    return data;
  };

  return data;
}

function _defaultErrorHandler() {
  const data = _interopRequireWildcard(require("./cli/default-error-handler"));

  _defaultErrorHandler = function () {
    return data;
  };

  return data;
}

function _commandRunner() {
  const data = require("./cli/command-runner");

  _commandRunner = function () {
    return data;
  };

  return data;
}

function _config() {
  const data = require("./extensions/config");

  _config = function () {
    return data;
  };

  return data;
}

function _bit() {
  const data = require("./extensions/bit");

  _bit = function () {
    return data;
  };

  return data;
}

function _cli() {
  const data = require("./extensions/cli");

  _cli = function () {
    return data;
  };

  return data;
}

// import Bluebird from 'bluebird';
process.env.MEMFS_DONT_WARN = 'true'; // suppress fs experimental warnings from memfs
// by default Bluebird enable the longStackTraces when env is `development`, or when
// BLUEBIRD_DEBUG is set.
// the drawback of enabling it all the time is a performance hit. (see http://bluebirdjs.com/docs/api/promise.longstacktraces.html)
// to override the default, uncomment the following, and set to true/false
// Bluebird.config({
//   longStackTraces: true
// });
// loudRejection();

_hooks().default.init();

try {
  _harmony().default.run(_config().ConfigExt).then(() => {
    return _harmony().default.set([_bit().BitExt]);
  }).then(() => {
    const cli = _harmony().default.get('CLIExtension');

    if (!cli) throw new Error(`failed to get CLIExtension from Harmony`); // @ts-ignore :TODO until refactoring cli extension to dynamically load extensions

    return cli.run();
  }).catch(err => {
    const originalError = err.originalError || err;
    const errorHandlerExist = (0, _defaultErrorHandler().findErrorDefinition)(originalError);
    let handledError;

    if (originalError instanceof _cli().PaperError) {
      // at this point CLI or Harmony might be broken. handling by paper
      _cli().PaperError.handleError(err);
    } else if (errorHandlerExist) {
      handledError = (0, _defaultErrorHandler().default)(originalError);
    } else {
      handledError = err;
    }

    (0, _commandRunner().logErrAndExit)(handledError, process.argv[1] || '');
  }); // Catching errors from the load phase

} catch (err) {
  const handledError = err instanceof _harmony().HarmonyError ? err.toString() : err;
  (0, _commandRunner().logErrAndExit)(handledError, process.argv[1] || '');
}