import { VERSION_DELIMITER } from '../constants';
import ScopesData, { ScopesOptions } from './e2e-scopes';
import BitJsonHelper from './e2e-bit-json-helper';
import FsHelper from './e2e-fs-helper';
import CommandHelper from './e2e-command-helper';
import ConfigHelper from './e2e-config-helper';
import BitMapHelper from './e2e-bitmap-helper';
import EnvHelper from './e2e-env-helper';
import ExtensionsHelper from './e2e-extensions-helper';
import FixtureHelper from './e2e-fixtures-helper';
import GeneralHelper from './e2e-general-helper';
import NpmHelper from './e2e-npm-helper';
import PackageJsonHelper from './e2e-package-json-helper';
import ScopeHelper from './e2e-scope-helper';
import GitHelper from './e2e-git-helper';
import BitJsoncHelper from './e2e-bit-jsonc-helper';
export declare type HelperOptions = {
    scopesOptions?: ScopesOptions;
};
export default class Helper {
    debugMode: boolean;
    scopes: ScopesData;
    bitJson: BitJsonHelper;
    bitJsonc: BitJsoncHelper;
    fs: FsHelper;
    command: CommandHelper;
    config: ConfigHelper;
    bitMap: BitMapHelper;
    env: EnvHelper;
    extensions: ExtensionsHelper;
    fixtures: FixtureHelper;
    general: GeneralHelper;
    npm: NpmHelper;
    packageJson: PackageJsonHelper;
    scopeHelper: ScopeHelper;
    git: GitHelper;
    constructor(helperOptions?: HelperOptions);
}
export declare function ensureAndWriteJson(filePath: string, fileContent: any): void;
export declare const FileStatusWithoutChalk: any;
export { VERSION_DELIMITER };
