import { Environments } from '../environments';
import { Workspace } from '../workspace';
import { Component } from '../component';
import { BuilderService } from './builder.service';
import { BitId } from '../../bit-id';
import { ScopeExtension } from '../scope';
import { IsolatorExtension } from '../isolator';
import { CLIExtension } from '../cli';
export declare type BuilderConfig = {
    parallel: 10;
};
export declare class BuilderExtension {
    private envs;
    private workspace;
    private service;
    static id: string;
    static dependencies: (import("@teambit/harmony").ExtensionManifest | typeof Environments | typeof CLIExtension | typeof IsolatorExtension | typeof ScopeExtension)[];
    constructor(envs: Environments, workspace: Workspace, service: BuilderService);
    tagListener(ids: BitId[]): Promise<{
        env: string;
        res: any;
    }[]>;
    build(components: Component[]): Promise<{
        env: string;
        res: any;
    }[]>;
    static provider([cli, envs, workspace, scope, isolator]: [CLIExtension, Environments, Workspace, ScopeExtension, IsolatorExtension]): Promise<BuilderExtension>;
}
