"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

function _bluebird() {
  const data = require("bluebird");

  _bluebird = function () {
    return data;
  };

  return data;
}

/**
 * A facade to resolve a component from the correct host
 *
 * @export
 * @class ComponentResolver
 */
class ComponentResolver {
  constructor(scope, workspace) {
    this.scope = scope;
    this.workspace = workspace;
  }
  /**
   * Get the actual host (workspace or scope)
   *
   * @readonly
   * @memberof ComponentResolver
   */


  get host() {
    if (this.workspace) {
      return this.workspace;
    }

    return this.scope;
  }

  getComponent(id) {
    return (0, _bluebird().coroutine)(function* () {
      if (!id) {
        return undefined;
      } // TODO: implement


      return undefined;
    })();
  }

}

exports.default = ComponentResolver;