"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

// eslint-disable-next-line import/no-cycle
// todo: change to "import type" once babel supports it

/**
 * `Snap` represents a sealed state of the component in the working tree.
 */
class Snap {
  constructor(timestamp, parents, author, message, state) {
    this.timestamp = timestamp;
    this.parents = parents;
    this.author = author;
    this.message = message;
    this.state = state;
  }
  /**
   * hash of the snap.
   */


  get hash() {
    // eslint-disable-line @typescript-eslint/no-unused-vars
    return this.state.hash;
  }
  /**
   * create a snap from a component
   */


  static create(component, author, message = '') {
    return new Snap(new Date(), component.head ? [component.head] : [], author, message, component.state);
  }

}

exports.default = Snap;