import { Harmony } from '@teambit/harmony';
import { Workspace } from '../workspace';
import { ScopeExtension } from '../scope';
import { Config } from '../config';
import { LogPublisher } from '../logger';
import { ExtensionConfigList } from '../../consumer/config';
import { ComponentHost } from '../types';
export default class Core {
    readonly harmony: Harmony;
    readonly config: Config | undefined;
    private logger;
    readonly scope: ScopeExtension;
    readonly workspace: Workspace | undefined;
    host: ComponentHost;
    constructor(harmony: Harmony, config: Config | undefined, logger: LogPublisher, scope: ScopeExtension, workspace: Workspace | undefined);
    get version(): string;
    init(): Promise<void>;
    loadExtensions(extensions: ExtensionConfigList): Promise<void>;
}
