/// <reference types="react" />
import { Packer } from './pack';
import { CommandOptions, Command } from '../cli';
declare type PackArgs = [string, string];
declare type PackFlags = {
    outDir: string;
    prefix?: boolean;
    override?: boolean;
    keep?: boolean;
    json?: boolean;
};
export declare class PackCmd implements Command {
    private packer;
    name: string;
    description: string;
    options: CommandOptions;
    shortDescription: string;
    alias: string;
    group: string;
    constructor(packer: Packer);
    render(args: PackArgs, options: PackFlags): Promise<JSX.Element>;
    json([componentId, scopePath]: PackArgs, options: PackFlags): Promise<{
        data: import("./pack").PackResult;
        code: number;
    }>;
}
export {};
