"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Workspace = Workspace;

function _react() {
  const data = _interopRequireDefault(require("react"));

  _react = function () {
    return data;
  };

  return data;
}

function _reactHooks() {
  const data = require("@apollo/react-hooks");

  _reactHooks = function () {
    return data;
  };

  return data;
}

function _apolloBoost() {
  const data = require("apollo-boost");

  _apolloBoost = function () {
    return data;
  };

  return data;
}

function _sideBar() {
  const data = require("./side-bar");

  _sideBar = function () {
    return data;
  };

  return data;
}

function _topBar() {
  const data = require("./top-bar");

  _topBar = function () {
    return data;
  };

  return data;
}

const WORKSPACE = (0, _apolloBoost().gql)`
  {
    workspace {
      path
      components {
        id
      }
    }
  }
`;

/**
 * main workspace component.
 */
function Workspace({
  topBarSlot
}) {
  const {
    loading,
    error,
    data
  } = (0, _reactHooks().useQuery)(WORKSPACE);
  if (loading) return /*#__PURE__*/_react().default.createElement("div", null, "loading");
  if (error) return /*#__PURE__*/_react().default.createElement("div", null, error.message);
  const workspace = data.workspace;
  return /*#__PURE__*/_react().default.createElement("div", null, /*#__PURE__*/_react().default.createElement(_topBar().TopBar, {
    topBarSlot: topBarSlot
  }), /*#__PURE__*/_react().default.createElement(_sideBar().SideBar, {
    components: workspace.components
  }));
}