import { BitIds } from '../bit-id';
import { BitIdStr } from '../bit-id/bit-id';
export declare type RemovedObjectSerialized = {
    removedComponentIds: BitIdStr[];
    missingComponents: BitIdStr[];
    removedDependencies: BitIdStr[];
    dependentBits: Record<string, any>;
};
export default class RemovedObjects {
    removedComponentIds: BitIds;
    missingComponents: BitIds;
    removedDependencies: BitIds;
    dependentBits: Record<string, any>;
    constructor({ removedComponentIds, missingComponents, removedDependencies, dependentBits }: {
        removedComponentIds?: BitIds;
        missingComponents?: BitIds;
        removedDependencies?: BitIds;
        dependentBits?: Record<string, any>;
    });
    serialize(): RemovedObjectSerialized;
    static fromObjects(payload: {
        removedComponentIds: string[];
        missingComponents: string[];
        removedDependencies: string[];
        dependentBits: {
            [key: string]: Record<string, any>[];
        };
    }): RemovedObjects;
}
